#ifndef aevent_h
#define aevent_h

#include <appleevents.h>

#ifndef inttypes_h
#include "inttypes.h"
#endif
#ifndef errorsource_h
#include "errorsource.h"
#endif
#ifndef aedesc_h
#include "aedesc.h"
#endif

class aevent: public aedesc
  {
	private:
		AppleEvent reply;
		AESendMode mode;
		AESendPriority priority;
		uint16 timeout;
		IdleProcPtr idler;
		EventFilterProcPtr filter;
		
	public:
		aevent( AEEventClass theclass,
				  AEEventID id,
				  const AEAddressDesc& target );
				
		void putparam( AEKeyword, DescType, void *, uint32 size );
		void putparam( AEKeyword, DescType, Handle );
		void putparam( AEKeyword, const AEDesc& );
				
		OSErr getparam( AEKeyword,
							 DescType desired,
							 DescType& realtype,
							 void *,
							 uint32 maxsize,
							 uint32& truesize );
				
		OSErr getparam( AEKeyword,
							 DescType desired,
							 DescType& realtype,
							 Handle& );

		OSErr getparam( AEKeyword,
							 DescType desired,
							 AEDesc& );
		
		void putattribute( AEKeyword, DescType, void *, uint32 size );
		void putattribute( AEKeyword, DescType, Handle );
		void putattribute( AEKeyword, const AEDesc& );
		
		operator AppleEvent&()			{ return (AppleEvent&)*this; }
		
		// there should be methods here to set the send params
		// and access the reply.
		
		OSErr send();
  };

#endif aevent_h
